package hatelace;

/** Simple class to represent the Program Counter */
public class ProgramCounter {
    private int PC;
    private int SysTick;

    private boolean haltFlag;

    public ProgramCounter() {
        this.PC = 0;
    }

    public ProgramCounter(int PC) {
        this.PC = PC;
    }

    public int getPC() {
        return this.PC;
    }
    
    public int getSysTicks() {
        return this.SysTick;
    }

    public int incPC() {
        this.PC = this.PC + 1 <= 0 ? 0 : this.PC + 1;
        this.SysTick += 1;
        return this.PC;
    }

    public int setPC(int PC) {
        this.PC = PC;
        this.SysTick += 1;
        return this.PC;
    }

    public boolean halted() {
        return this.haltFlag;
    }

    public void halt() {
        this.haltFlag = true;
    }
}
